// A fan game by poret. This game is not affiliated with SNK. This is a fan game which is not being sold or distributed for profit.

#pragma once

#include "CoreMinimal.h"
#include "Camera/CameraActor.h"
#include "KOFDefaultCamera.generated.h"

/**
 * 
 */
UCLASS()
class KOFFOREVER_API AKOFDefaultCamera : public ACameraActor
{
	GENERATED_BODY()

public:
	AKOFDefaultCamera();

	virtual void Tick(float DeltaSeconds) override;
protected:
	/**
	 *	Min FOV camera will zoom in to as character's walk farther apart from each other.
	 *
	 *	
	 */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = CameraSettings, meta = (UIMin = "5.0", UIMax = "170", ClampMin = "0.001", ClampMax = "360.0", Units = deg))
	float MinFOV;

	/** Max FOV camera will zoom out to as character's walk farther apart from each other */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = CameraSettings, meta = (UIMin = "5.0", UIMax = "170", ClampMin = "0.001", ClampMax = "360.0", Units = deg))
	float MaxFOV;

	/** Offset added to the camera's Z value after performing the character mid point calculation */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = CameraSettings)
	float HeightOffset;

	/**
	 *	Value used when averaging both character's Z positions to find the camera's final Z position.
	 *
	 *	A value of 2.0 will set the camera's Z position to the midpoint between both character's Z positions.
	 *	A value less than 2.0 will keep the camera closer to the ground even as another player jumps.
	 */
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category = CameraSettings)
	float ZAveragingFactor;

	/**
	 *	How far the character's have to be apart before the camera moves to keep both in frame
	 */
	float MovementYDistanceThreshold;

	void UpdateCamera();
};
